/*
    grammar.h
    $Id: grammar.h,v 1.12 2014/12/18 01:30:34 daichi Exp $

*/
#ifndef PCFG_GRAMMAR_H
#define PCFG_GRAMMAR_H
#include "tree.h"
#include "util.h"
#include <vector>
#include <utility>

using namespace std;

struct Grammar {
	int K;
	int V;
	double a, b;
	double gamma;
	double eta;
	vector<int> wtotal;
	vector<int> rtotal;
	vector<hash_map<int,int> > wcounts;
	vector<hash_map<tuple,int> > rcounts;

	double rulep (int x);
	double expand (int x, int w);
	double expand (int x, int y, int z);
	
	bool add_counts (Tree *tree);
	bool remove_counts (Tree *tree);

	double treelik (Tree *tree);
	double polyalik (Tree *tree);

	Grammar (int K_, double gamma_, double eta_);

	void save (char *model);
	void print ();
	void test ();
};

namespace std {
namespace tr1 {
	template <> struct hash <pair<int,int> >
	{
		size_t operator() (const pair<int,int> &x) const
		{
			return x.first * 131 + x.second;
		}
	};
	template <> struct hash <pair<int,tuple> >
	{
		size_t operator() (const pair<int,tuple> &x) const
		{
			return x.first * 131 + x.second.first * 191 + x.second.second;
		}
	};
}
}


#endif
