/*
    random.h
    $Id: random.h,v 1.3 2014/12/11 07:23:36 daichi Exp $

*/
#ifndef __RANDOM_H__
#define __RANDOM_H__
#include <vector>
#include <gsl/gsl_randist.h>
#include "mt.h"
#define	RANDOM	genrand()
#define betad	gsl_ran_beta_pdf

using namespace std;

int irand (int n);
double exprand (void);
double sgamrand (double a);
double gamrand (double a, double b);
double betarand (double a, double b);
double lbetad (double x, double a, double b);
int bernoulli (double p);
int multinom (vector<double> &v, int K=-1);
int lmultinom (vector<double> &v, int K=-1);
int draw_discrete (double *table, int n);
int draw_discrete_int (int *table, int n);
int draw_probability (double *table, int n);
int draw_likelihood (double *lik, int n);
void fisher_yates_shuffle (int *v, int n);

#endif


    
