/*
    tree.h
    $Id: tree.h,v 1.7 2014/12/17 11:22:22 daichi Exp $

*/
#ifndef PCFG_TREE_H
#define PCFG_TREE_H
#include <string>
#include "dict.h"

using namespace std;

typedef void (*nodefunc)(int x, int y, int z, void *arg);
typedef void (*splitfunc)(int n, int x, int y, int z, void *arg);
typedef void (*treefunc)(int i, int j, int x, int y, int z, void *arg);

struct Tree {
	int category;
	int word;
	Tree *left;
	Tree *right;

	int nodes ();
	void foreach (nodefunc func, void *arg);
	void splits (splitfunc func, void *arg);
	void splits_ (int st, splitfunc func, void *arg);
	void traverse (treefunc func, void *arg);
	void traverse_ (int st, treefunc func, void *arg);
	void print ();
	string stringify (dictionary *dict=NULL);

	Tree (int c, int word_)
	{
		category = c;
		word = word_;
		left = NULL;
		right = NULL;
	}

	Tree (int c, Tree *left_, Tree *right_)
	{
		category = c;
		word = -1;
		left = left_;
		right = right_;
	}

	~Tree ()
	{
		if (left) delete left;
		if (right) delete right;
	}

};



#endif

